/* Include all relevant sunview, suntool, and graphics handling systems */
#include <math.h>
#include <stdio.h>

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/scrollbar.h>
#include <xview/icon.h>
#include <xview/canvas.h>
#include <xview/textsw.h>
#include <xview/cursor.h>
#include <xview/cms.h>

/* include the trig functions */


/* declare subs */
static void     default_proc(), quit_proc(), close_proc(), value_proc(), vectex();
static void     help_done(), setrot();
static void     _rdrw(), _help(), _a3(), _a4(), prev_proc(), next_proc(), font_load(), create_fills();
static void     inc_proc(), font_proc(), vectex2(), backgr_proc();
static void     rdproc(), redraw();
static Notify_value    _winevent();

/* define font variables */
u_char          font[500000], helpfn[80];
int             unusestfname = 0;
int             indx[256], imed;
float           art = (3 / 5.5);

/* define global window variables */
#define MY_CMS_SIZE 8
#define PI  3.1415926
#define cfac  0.017453292

char            metatmp[80];
int             resolut[4] = {75, 100, 150, 300};
float           rest, irest;
int             trest, mchf;
Frame           frame;
Frame           frame2;
Frame           frame3;
Canvas          posiwin;
Textsw          helpwind;
Textsw          communic4;
Panel           panel;
Panel           panel2;
Panel           panel3;
Panel_item      hpfiledata, hpfilecycle;
Scrollbar       xscol, yscol;
int             xscroll, yscroll;
int             ex, ey, pid = 0;
Server_image    icon_image;
Icon            icon;
Canvas          canvas, canvas3;
Panel_item      value;
Pixwin         *pw, *pw3;
Pixrect        *mpr[20];
float           wsx, wsy;
float           wx = 0.;
float           wy = 0.;
float           wlx = 1141.;
float           wly = 821.;
float           matrix[3][3];
float           nwx, nwy, nwlx, nwly;
float           tx, ty, cx, cy, p, tsp;
static struct pr_pos cirpnt[10000];

u_char          red[MY_CMS_SIZE], green[MY_CMS_SIZE], blue[MY_CMS_SIZE];
int             ap = 3, lp = 1, fn = 1, helpon = 0, sliderval, incremval = 1;
int             oldsex, oldsey, oldenx, oldeny, jdrb = 0, bth = 0, voldsex,
                voldsey;
int             printrun = FALSE;
int             fontset = 0, backgr = 0;

#define IBMAT 0
#define IBMATS 1
#define SWISS 2
#define SWISSS 3
char            stfname[50];
int             usestfname = TRUE;

/* define the icon for this program */
static short    icon_bits[] = {
#include "metaview.icon"
};






char * addenv(s)
char *s;
{
static char add_ret[1024];
char *path;
char *getenv();

path=getenv("X_METAVIEW");

if (!path) {
	fprintf(stderr,"Please set the environment varibale X_METAVIEW\n");
	fprintf(stderr,"to point to the place where x_metaview is installed\n");
	exit(1);
}


sprintf(add_ret,"%s/%s",path,s);

return(add_ret);
}

main(argc, argv)
  int             argc;
  char          **argv;
{
  Pixwin         *pw2;
  int             tmp;




fprintf(stderr,"*****WARNING beta version of unsupported code\n");
  sprintf(metatmp, "/tmp/metatmp.%d", getpid());

  if (argc == 2) {
    usestfname = FALSE;
    strcpy(stfname, argv[1]);
  }
  red[0] = 254;
  green[0] = 254;
  blue[0] = 254;
  red[1] = 1;
  green[1] = 1;
  blue[1] = 1;
  red[4] = 255;
  green[4] = 1;
  blue[4] = 1;
  red[3] = 1;
  green[3] = 255;
  blue[3] = 1;
  red[2] = 1;
  green[2] = 1;
  blue[2] = 255;
  red[7] = 254;
  green[7] = 254;
  blue[7] = 254;
  red[8] = 254;
  green[8] = 254;
  blue[8] = 254;
  for (tmp = 8; tmp < MY_CMS_SIZE; tmp++)
    red[tmp] = blue[tmp] = green[tmp] = 1;
  tmp = MY_CMS_SIZE - 2;
  red[tmp] = blue[tmp] = green[tmp] = 254;


  icon_image = (Server_image) xv_create(NULL, SERVER_IMAGE,
	   XV_HEIGHT, 64, XV_WIDTH, 64, SERVER_IMAGE_BITS, icon_bits, 0);


  icon = xv_create(NULL, ICON,
		   ICON_IMAGE, icon_image, NULL);

  frame = window_create(NULL, FRAME,
			FRAME_CLOSED, TRUE,
			FRAME_LABEL, "Metaiew V6.97",
			FRAME_ICON, icon,
			0);


  panel = window_create(frame, PANEL,
			WIN_WIDTH, 576,
			WIN_HEIGHT, 100,
			0);




  create_panel_items();




  canvas = window_create(frame, CANVAS,
			 CANVAS_AUTO_SHRINK, TRUE,
			 CANVAS_AUTO_EXPAND, TRUE,
			 CANVAS_RETAINED, FALSE,
			 CANVAS_REPAINT_PROC, redraw,
			 CANVAS_RESIZE_PROC,redraw,
			 WIN_WIDTH, 576,
			 WIN_HEIGHT, 395,
			 WIN_X, 0,
			 WIN_Y, 105,
			 0);


  xv_set(canvas_paint_window(canvas),
			 CANVAS_AUTO_SHRINK, TRUE,
			 CANVAS_AUTO_EXPAND, TRUE,
	 WIN_EVENT_PROC, _winevent,
	 WIN_CONSUME_EVENTS,
	 LOC_DRAG, LOC_MOVE, WIN_MOUSE_BUTTONS,
	 NULL,
	 NULL);
  

  pw = canvas_pixwin(canvas);
  pw_setcmsname(pw, "metaview");
  pw_putcolormaps(pw, 0, MY_CMS_SIZE, red, green, blue);


  frame2 = window_create(frame, FRAME,
			 WIN_SHOW, FALSE,
			 FRAME_SHOW_LABEL, TRUE,
			 FRAME_LABEL,
		"Metaview V6.97 NMI (Nearly Machine Independant) - Help",
			 WIN_X, 250,
			 WIN_Y, 200,
			 WIN_WIDTH, 750,
			 WIN_HEIGHT, 630,
			 FRAME_DONE_PROC, help_done,
			 FRAME_NO_CONFIRM, TRUE,
			 0);
  panel2 = window_create(frame2, PANEL,
			 WIN_HEIGHT, 190,
			 0);
  create_help_items();
  helpwind = window_create(frame2, TEXTSW, TEXTSW_CONFIRM_OVERWRITE, FALSE,
			   TEXTSW_INSERT_MAKES_VISIBLE, TRUE, 0);

  /*
   * frame3 = window_create(frame, FRAME, FRAME_SHOW_LABEL, FALSE, WIN_X,
   * 215, WIN_WIDTH, 760, WIN_Y, 150, WIN_HEIGHT, 500, WIN_SHOW, FALSE,
   * FRAME_DONE_PROC, hpoutdone, 0); panel3 = window_create(frame3, PANEL,
   * WIN_WIDTH, 400, WIN_HEIGHT, 45, 0); communic4 = window_create(frame3,
   * TEXTSW, WIN_X, 0, WIN_Y, 50, WIN_WIDTH, 400, WIN_HEIGHT, 45,
   * WIN_SHOW, TRUE, 0); posiwin = window_create(frame3, CANVAS, WIN_X,
   * 405, WIN_Y, 0, WIN_WIDTH, 360, WIN_HEIGHT, 500, WIN_CONSUME_EVENTS,
   * LOC_DRAG, ACTION_ADJUST, 0, WIN_EVENT_PROC, hpwinevent, 0); canvas3 =
   * window_create(frame3, CANVAS, CANVAS_AUTO_SHRINK, FALSE,
   * CANVAS_RETAINED, TRUE, WIN_X, 0, WIN_Y, 100, WIN_WIDTH, 400,
   * WIN_HEIGHT, 400, CANVAS_WIDTH, 1872, CANVAS_HEIGHT, 2880,
   * WIN_VERTICAL_SCROLLBAR, yscol = scrollbar_create( SCROLL_LINE_HEIGHT,
   * 1, 0), WIN_HORIZONTAL_SCROLLBAR, xscol = scrollbar_create(
   * SCROLL_LINE_HEIGHT, 1, 0), 0);
   * 
   * pw3 = canvas_pixwin(canvas3); pw_setcmsname(pw3, "metaview2"); pw2 =
   * pw3; red3[0] = 254; green3[0] = 254; blue3[0] = 254; red3[1] = 1;
   * green3[1] = 1; blue3[1] = 1; red3[2] = 1; green3[2] = 1; blue3[2] =
   * 1; pw_putcolormap(pw3, 0, 2, red3, green3, blue3);
   * create_panel_item2();
   * 
   * pw = canvas_pixwin(posiwin); pw_setcmsname(pw, "metaview2");
   * pw_putcolormap(pw, 0, 2, red3, green3, blue3); pw =
   * canvas_pixwin(canvas);
   */


  if (usestfname == TRUE) {
    ap = 4;
    wx = (float) -67.00;
    wy = (float) -104.00;
    wlx = (float) 27075.00;
    wly = (float) 17820.00;
  } else {
    ap = 3;
    wx = (float) 0.00;
    wy = (float) 0.00;
    wlx = (float) 45514.752;
    wly = (float) 32767.00;
  }

  fontset = IBMAT;
  font_load(fontset);
  /*
   * c
   * 
   * r
   * e
   * a t e _ f i l l s ( ) ;
   */
  window_fit(frame);

  window_set(frame, FRAME_CLOSED, FALSE, 0);
  window_main_loop(frame);

}

static void
print()
{
  pw = pw3;
  printrun = TRUE;
  redraw();
  pw = canvas_pixwin(posiwin);
  printrun = 2;
  if (pid == 0)
    redraw();
  pid = 0;
  printrun = FALSE;
  pw = canvas_pixwin(canvas);
}
static void
hpoutdone()
{
  window_set(frame3, WIN_SHOW, FALSE, 0);
}

hpoutsave()
{
  /*
   * FILE *hpoutfile; int xpr, ypr; Pixwin *pw2; Pixrect *mem, *scrn; char
   * *start, *ptr; int ht, wid; colormap_t *colormap = 0; pid = 1;
   * print(); pid = 0; pw2 = pw3; hpoutfile = fopen(metatmp, "w"); mem =
   * pw2->pw_prretained; pw_batch_on(pw2); pr_dump(mem, hpoutfile, 0,
   * RT_STANDARD, 1); pw_batch_off(pw2); fclose(hpoutfile);
   */
}

hpoutconvert()
{
  u_char          storage[235], st;
  int             storptr = 0, eostpt = 0;
  char            commun[50];
  FILE           *hpoutfile;
  FILE           *hpinfile;
  int             ci, ca, cb;
  char            junk[80];


  sprintf(commun, "Starting conversion from RASTER to HP format\n");
  textsw_insert(communic4, commun, 45);
  hpoutsave();
  sprintf(commun, "Conversion proceeding\n");
  textsw_insert(communic4, commun, 22);
  sprintf(junk, "%s", panel_get_value(hpfiledata));
  hpinfile = fopen(metatmp, "r");
  hpoutfile = fopen(junk, "w");
  if (hpoutfile != NULL) {
    for (ci = 1; ci <= 32; ++ci)
      getc(hpinfile);
    putc(27, hpoutfile);
    putc('E', hpoutfile);
    fprintf(hpoutfile, "%c*t%dR", 27, trest);
    fprintf(hpoutfile, "%c*p150X%c*p195Y", 27, 27);
    fprintf(hpoutfile, "%c*r1A", 27);
    for (ca = 1; ca < 2867; ++ca) {
      storptr = 1;
      eostpt = 0;
      for (cb = 1; cb < 235; ++cb) {
	st = (u_char) getc(hpinfile);
	if (st != 0)
	  eostpt = storptr;
	storage[storptr++] = st;
      }
      fprintf(hpoutfile, "%c*b%dW", 27, eostpt);
      for (cb = 1; cb <= eostpt; ++cb)
	putc((int) storage[cb], hpoutfile);
    }
    fprintf(hpoutfile, "%c*rB", 27);
    putc(27, hpoutfile);
    putc('E', hpoutfile);
    putc(27, hpoutfile);
    putc('E', hpoutfile);

    sprintf(commun, "Conversion done: %s\n", panel_get_value(hpfiledata));
    textsw_insert(communic4, commun, strlen(commun));
    fclose(hpinfile);
  } else {
    sprintf(commun, "Could not open HP output file\n");
    textsw_insert(communic4, commun, 30);
  }
  fclose(hpoutfile);
  unlink(metatmp);
}




static          Notify_value
hpwinevent(evwin, evnt, evargs)
  Window          evwin;
  Event          *evnt;
  caddr_t         evargs;
{

  ex = (int) ((event_x(evnt) * 5.202) * rest) - 200;
  ey = (int) ((event_y(evnt) * 5.202) * rest) - 200;
  scrollbar_scroll_to(xscol, ex);
  scrollbar_scroll_to(yscol, ey);
}

static void
resthan(un1, rst, un3)
  Panel_item      un1;
  int             rst;
  Event          *un3;
{
  rest = resolut[rst] / 300.;
  irest = 1. / rest;
  trest = resolut[rst];
  print();
}

static void
hpoutwanted()
{
  Panel_item      un1;
  int             rst = 2;
  Event          *un3;

  resthan(un1, rst, un3);

  window_set(frame3, WIN_SHOW, TRUE, 0);
}


static void
help_done()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(frame2, WIN_SHOW, FALSE, 0);
}
static void
ha3()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/a3"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}
static void
ha4()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/a4"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}
static void
hba()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/backgrou"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}
static void
hcl()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/close"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}
static void
hco()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/convert"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}
static void
hdo()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/done"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}
static void
hfo()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/font"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}
static void
hhe()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/help"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}
static void
hhp()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/hpfile"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}
static void
hhpo()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/hpout"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}
static void
hin()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/incremen"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}
static void
hne()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/next"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}
static void
hpr()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/prev"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}
static void
hpre()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/preview"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}
static void
hqu()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/quit"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}
static void
hre()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/redraw"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}
static void
hres()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/resoluti"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}
static void
hmo()
{
  if (((int) window_get(helpwind, TEXTSW_MODIFIED)) == TRUE)
    textsw_store_file(helpwind, helpfn, 0, 0);
  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/mouse"), TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);
}



create_help_items()
{
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Done",
		    PANEL_NOTIFY_PROC, help_done,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_ITEM_Y, 30,
		    PANEL_ITEM_X, 5,
		    PANEL_LABEL_STRING, "Help on Help",
		    PANEL_NOTIFY_PROC, _help,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "A3?         ",
		    PANEL_NOTIFY_PROC, ha3,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "A4?         ",
		    PANEL_NOTIFY_PROC, ha4,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Backgroud:? ",
		    PANEL_NOTIFY_PROC, hba,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Close?      ",
		    PANEL_NOTIFY_PROC, hcl,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Convert?    ",
		    PANEL_NOTIFY_PROC, hco,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Done?       ",
		    PANEL_NOTIFY_PROC, hdo,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Font:?      ",
		    PANEL_NOTIFY_PROC, hfo,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Help?       ",
		    PANEL_NOTIFY_PROC, hhe,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "HP file:?   ",
		    PANEL_NOTIFY_PROC, hhp,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Hpout?      ",
		    PANEL_NOTIFY_PROC, hhpo,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Increment?  ",
		    PANEL_NOTIFY_PROC, hin,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Next?       ",
		    PANEL_NOTIFY_PROC, hne,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Prev?       ",
		    PANEL_NOTIFY_PROC, hpr,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Preview?    ",
		    PANEL_NOTIFY_PROC, hpre,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Quit?       ",
		    PANEL_NOTIFY_PROC, hqu,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Redraw?     ",
		    PANEL_NOTIFY_PROC, hre,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Resolution:?",
		    PANEL_NOTIFY_PROC, hres,
		    0);
  panel_create_item(panel2, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "The mouse:? ",
		    PANEL_NOTIFY_PROC, hmo,
		    0);

}

create_panel_item2()
{
  int             rst;

  panel_create_item(panel3, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Preview",
		    PANEL_NOTIFY_PROC, print,
		    0);
  panel_create_item(panel3, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Convert",
		    PANEL_NOTIFY_PROC, hpoutconvert,
		    0);
  panel_create_item(panel3, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Done",
		    PANEL_NOTIFY_PROC, hpoutdone,
		    0);
  hpfilecycle = panel_create_item(panel3, PANEL_CYCLE,
				  PANEL_LABEL_STRING, "Resolution:",
     PANEL_CHOICE_STRINGS, " 75 dpi", "100 dpi", "150 dpi", "300 dpi", 0,
				  PANEL_NOTIFY_LEVEL, PANEL_ALL,
				  PANEL_NOTIFY_PROC, resthan,
				  PANEL_VALUE, 2,
				  0);
  /* default reolution */


  hpfiledata = panel_create_item(panel3, PANEL_TEXT,
				 PANEL_LABEL_STRING, "HP file:",
				 PANEL_VALUE_DISPLAY_LENGTH, 20,
				 PANEL_NOTIFY_LEVEL, PANEL_NONE,
				 0);

}

create_panel_items()
{

  panel_create_item(panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Help",
		    PANEL_NOTIFY_PROC, _help,
		    0);
  panel_create_item(panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Redraw",
		    PANEL_NOTIFY_PROC, _rdrw,
		    0);
  panel_create_item(panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "A4",
		    PANEL_NOTIFY_PROC, _a4,
		    0);
  panel_create_item(panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "A3",
		    PANEL_NOTIFY_PROC, _a3,
		    0);
  panel_create_item(panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Next",
		    PANEL_NOTIFY_PROC, next_proc,
		    0);
  panel_create_item(panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Prev",
		    PANEL_NOTIFY_PROC, prev_proc,
		    0);

  /*
   * panel_create_item(panel, PANEL_BUTTON, PANEL_LABEL_STRING,"Hpout",
   * PANEL_NOTIFY_PROC, hpoutwanted, 0);
   */
  panel_create_item(panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Close",
		    PANEL_NOTIFY_PROC, close_proc,
		    0);
  panel_create_item(panel, PANEL_BUTTON,
		    PANEL_LABEL_STRING, "Quit",
		    PANEL_NOTIFY_PROC, quit_proc,
		    0);
  panel_create_item(panel, PANEL_CYCLE,
		    PANEL_LABEL_STRING, "Increment:",
		    PANEL_CHOICE_STRINGS, "+-1", "+-2", "+-3",
		    "+-4", "+-5", "+-6", "+-7", "+-8", "+-9", 0,
		    PANEL_NOTIFY_PROC, inc_proc,
		    0);
  panel_create_item(panel, PANEL_CYCLE,
		    PANEL_LABEL_STRING, "Fonts:",
		 PANEL_CHOICE_STRINGS, "IBM AT", "IBM AT-SOLID", "SWISS",
		    "SWISS-SOLID", 0,
		    PANEL_NOTIFY_PROC, font_proc,
		    0);
  panel_create_item(panel, PANEL_CYCLE,
		    PANEL_LABEL_STRING, "Background:",
		    PANEL_CHOICE_STRINGS, "White", "Black", 0,
		    PANEL_NOTIFY_PROC, backgr_proc,
		    0);
}


static void
flget()
{
  p = sliderval / 100.;
  if (p == 0)
    p = -1.;
}

static void
redraw()
{
  float           x1, x2, y1, y2, x, y, ox, oy, sz, xa, th, hx, hy,
                  stx, lthc, r1, r, cth;
  int             lwid, lwid1, lwid2, cwid, cwid1, cwid2, ccol, ir1,
                  ir2, pr, cfill1, cfill2, cfill3, cfill4, cfill5;
  int             ix1, ix2, iy1, iy2, n, i, a, b, c, d, cc, q, lcol,
                  tcol, px, py, done;
  int             curs = 1;
  int             curt = 0;
  register int    dc;
  FILE           *in_file;
  char            txtstr[2];
  char            txtstr2[1];
  char            txtstr3[256];
  char            frmelble[256];
  struct pr_brush bru, *bru2;

  dc = 1;
  lcol = 1;
  lwid = 1;
  bth = 0;
  done = FALSE;
  cfill1 = -1;
  cfill2 = -1;
  cfill3 = -1;
  cfill5 = 1;
  if (fn < 10)
    sprintf(txtstr3, "metafile.0%d", fn);
  else
    sprintf(txtstr3, "metafile.%d", fn);

  if (usestfname == FALSE)
    sprintf(txtstr3, "%s", stfname);
  sprintf(frmelble, "Metaview %s: Viewing %s", "V1.0", txtstr3);
  window_set(frame,
	     FRAME_LABEL, frmelble,
	     0);

  if (printrun == TRUE) {
    wsx = 2601 * rest;
    wsy = 1872 * rest;
  }
  if (printrun == FALSE) {
    wsx = (float) (int) window_get(canvas, WIN_WIDTH);
    wsy = (float) (int) window_get(canvas, WIN_HEIGHT);
    wsx = wsy * (1.389);
  }
  if (printrun == 2) {
    wsx = 500;
    wsy = 360;
    printrun = TRUE;
  }
  if (printrun == FALSE) {
    ix1 = (int) window_get(canvas, WIN_WIDTH);
    iy1 = (int) window_get(canvas, WIN_HEIGHT);
    pw_rop(pw, 0, 0, ix1, iy1, PIX_SRC | PIX_COLOR(backgr), (Pixrect *) 0, 0, 0);
  } else {
    /*
     * pw_rop(pw, 0, 0, pw->pw_prretained->pr_size.x,
     * pw->pw_prretained->pr_size.y, PIX_SRC | PIX_COLOR(0), (Pixrect *)
     * 0, 0, 0);
     */
  }

  in_file = fopen(txtstr3, "r");
  if (in_file == NULL) {
  } else {

    cx = -wx;
    cy = -wy;
    tx = (float) (wsx / wlx);
    ty = (float) (wsy / wly);
    tx=ty;


    for (i = 1; i <= 592; ++i) {
      c = getc(in_file);
    }

    curt = 60;
    while (done == FALSE) {
      curt++;
      if (curt > 50) {
	curt = 0;
	++curs;
	if (curs > 6)
	  curs = 1;
      }
      a = getc(in_file);
      if (a == 80) {
	b = getc(in_file);
	if (b == 130) {
	  lcol = getc(in_file);
	  lcol = getc(in_file);
	  if ((printrun == FALSE) && (backgr == 1))
	    if (lcol == 1)
	      lcol = 0;

	}
	if (b == 98) {
	  lwid1 = getc(in_file);
	  lwid2 = getc(in_file);
	  lthc = (float) tx *5.2;

	  if (lwid2 == 1)
	    lwid = (int) 1;
	  if (lwid2 == 30)
	    lwid = (int) 3 *lthc;

	  if (lwid2 == 80)
	    lwid = (int) 5 *lthc;

	  if (lwid2 == 175)
	    lwid = (int) 7 *lthc;

	  if (lwid2 == 19)
	    lwid = (int) 9 *lthc;

	  if (lwid <= 0)
	    lwid = 0;
	}
      }
      if (a == 81) {
	b = getc(in_file);
	if (b == 194) {
	  tcol = getc(in_file);
	  tcol = getc(in_file);
	  if ((printrun == FALSE) && (backgr == 1))
	    if (tcol == 1)
	      tcol = 0;
	}
	if (b == 66) {
	  c = getc(in_file);
	  c = getc(in_file);
	}
	if (b == 226) {
	  c = getc(in_file);
	  d = getc(in_file);
	  sz = (float) (c * 256. + d);
	  sz = (float) (sz / 141.);
	}
      }
      if (a == 82) {
	b = getc(in_file);
	if (b == 226) {
	  d = getc(in_file);
	  d = getc(in_file);
	}
	if (b == 194) {
	  d = getc(in_file);
	  cfill3 = getc(in_file);
	}
	if (b == 8) {
	  ix1 = getc(in_file);
	  ix1 = getc(in_file);
	  ix1 = getc(in_file);
	  ix2 = getc(in_file);
	  px = (ix1 * 256 + ix2);
	  iy1 = getc(in_file);
	  iy1 = getc(in_file);
	  iy1 = getc(in_file);
	  iy2 = getc(in_file);
	  py = (iy1 * 256 + iy2);

	  if (px > 32768)
	    px = -(65536 - px);
	  if (py > 32768)
	    px = -(65536 - px);

	  if (px == 0)
	    th = (float) 90.;
	  else {
	    th = (float) atan((double) (py / px));
	    th = (float) (th) / (cfac);
	  }

	  if ((px > 0) && (py > 0))
	    th = (float) abs(th);
	  if ((px < 0) && (py > 0))
	    th = (float) (90. + (90. - abs(th)));
	  if ((px < 0) && (py = 0))
	    th = (float) 180.;
	  if ((px = 0) && (py < 0))
	    th = (float) 270.;
	  if ((px > 0) && (py > 0))
	    th = (float) (270. + (90. - abs(th)));
	  if ((px > 0) && (py > 0))
	    th = (float) (180. + abs(th));

	}
	if (b == 76) {
	  for (i = 1; i <= 12; ++i)
	    c = getc(in_file);
	  c = getc(in_file);
	  c = getc(in_file);
	  if (c == 159) {
	    c = getc(in_file);
	    c = getc(in_file);
	  }
	  ix1 = getc(in_file);
	  ix2 = getc(in_file);
	  iy1 = getc(in_file);
	  iy2 = getc(in_file);
	  px = (ix1 * 256 + ix2);
	  py = (iy1 * 256 + iy2);
	  xa = (float) (141. * sz);
	  y = (float) y;	/*-(xa/2.0);*/
	  x = (float) px;
	  y = (float) py;

	  hx = (float) (x);
	  hy = (float) (y);
	  hx = (float) (hx - cx);
	  hy = (float) (hy - cy);
	  hx = (float) (hx * tx);
	  hy = (float) (hy * ty);
	  setrot(th);

	  c = getc(in_file);
	  c = getc(in_file);
	  c = getc(in_file);

	  for (i = 1; i <= c; ++i) {

	    ix2 = getc(in_file);
	    if (fontset < 2)
	      vectex(x, y, xa, tcol, ix2, hx, hy);
	    else
	      vectex2(x, y, xa, tcol, ix2, hx, hy);

	    x = (float) (x + tsp);
	  }

	  i = (c + 1) % 2;
	  if (i == 1)
	    c = getc(in_file);
	}
      }
      if (a == 64) {
	c = getc(in_file);
	cc = c;
	if (cc < 64) {
	  if (c == 63) {
	    ix1 = getc(in_file);
	    ix2 = getc(in_file);
	    c = ix1 * 256 + ix2;
	    c = c + 32;
	  }
	  c = c - 32;
	  c = (int) c / 4;
	  dc = (lcol);
	  bru.width = (short) lwid;
	  for (i = 1; i <= c; ++i) {
	    ix1 = getc(in_file);
	    ix2 = getc(in_file);
	    iy1 = getc(in_file);
	    iy2 = getc(in_file);
	    px = (ix1 * 256 + ix2);
	    py = (iy1 * 256 + iy2);
	    x = (float) px;
	    y = (float) py;
	    x = (float) (x - cx);
	    y = (float) (y - cy);
	    x = (float) (x * tx);
	    y = (float) (y * ty);
	    if (i == 1) {
	      ox = x;
	      oy = y;
	    }
	    ix1 = (int) x;
	    iy1 = (int) (wsy - y);
	    ix2 = (int) ox;
	    iy2 = (int) (wsy - oy);
	    if (printrun == TRUE) {
	      imed = iy1;
	      iy1 = ix1;
	      ix1 = wsy - imed;
	      imed = iy2;
	      iy2 = ix2;
	      ix2 = wsy - imed;
	    }
	    if ((ix1 < 65535 && ix1 > -65535) &&
		(ix2 < 65535 && ix2 > -65535) &&
		(iy1 < 65535 && iy1 > -65535) &&
		(iy2 < 65535 && iy2 > -65535)) {
	      pw_line(pw, ix1, iy1, ix2, iy2, &bru, 0,
		      PIX_SRC | PIX_COLOR(dc));
	    }
	    ox = x;
	    oy = y;
	  }
	}
	if (cc > 64) {
	  if (c == 63) {
	    ix1 = getc(in_file);
	    ix2 = getc(in_file);
	    c = ix1 * 256 + ix2;
	    c = c + 224;
	  }
	  c = c - 224;
	  c = (int) c / 4;
	  d = 0;
	  dc = (ccol);
	  bru.width = (short) cwid;
	  for (i = 1; i <= c; ++i) {
	    ix1 = getc(in_file);
	    ix2 = getc(in_file);
	    iy1 = getc(in_file);
	    iy2 = getc(in_file);
	    px = (ix1 * 256 + ix2);
	    py = (iy1 * 256 + iy2);
	    x = (float) px;
	    y = (float) py;
	    x = (float) (x - cx);
	    y = (float) (y - cy);
	    x = (float) (x * tx);
	    y = (float) (y * ty);
	    ix1 = (int) x;
	    iy1 = (int) (wsy - y);
	    if (printrun == TRUE) {
	      imed = iy1;
	      iy1 = ix1;
	      ix1 = wsy - imed;
	    }
	    if (ix1 < 65535 && ix1 > -65535) {
	      if (ix2 < 65535 && ix2 > -65535) {
		cirpnt[d].x = ix1;
		cirpnt[d++].y = iy1;
	      }
	    }
	  }


	  if (cfill1 == 0) {
	    if (cfill2 == 06)
	      cfill4 = 2;
	    if (cfill2 == 03)
	      cfill4 = 3;
	    if (cfill2 == 04)
	      cfill4 = 4;
	    if (cfill2 == 01)
	      cfill4 = 5;
	    if (cfill2 == 02)
	      cfill4 = 6;
	    if (cfill2 == 05)
	      cfill4 = 7;
	  }
	  if (cfill1 == 255) {
	    if (cfill2 == 246)
	      cfill4 = 10;
	    if (cfill2 == 245)
	      cfill4 = 11;
	    if (cfill2 == 244)
	      cfill4 = 12;
	    if (cfill2 == 243)
	      cfill4 = 13;
	    if (cfill2 == 241)
	      cfill4 = 14;
	  }
	  if (cfill3 == 1)
	    cfill4 = 1;
	  if (cfill3 == 4)
	    cfill4 = 8;
	  cfill1 = -1;
	  cfill2 = -1;
	  cfill3 = -1;
	  /*
	   * w
	   * 
	   * _
	   * p
	   * o l y g o n _ 2 ( p w ,
	   * 
	   * 0 ,
	   * 
	   * 
	   * 
	   * ,
	   * 0
	   * 
	   * ,
	   * 1
	   * 
	   * ,
	   * &
	   * 
	   * d
	   * ,
	   * 
	   * c
	   * 
	   * i
	   * r
	   * 
	   * p
	   * n t ,
	   * 
	   * P ,
	   * 
	   * 
	   * 
	   * I
	   * X
	   * 
	   * _
	   * S R C
	   * 
	   * | C
	   * 
	   * 
	   * 
	   * P
	   * I
	   * X I
	   * 
	   * _
	   * C O L O R ( d c ) ,
	   * 
	   * m ,
	   * 
	   * 
	   * 
	   * p
	   * r
	   * 
	   * [
	   * c f i l l 4 ] ,
	   * 
	   * 0 ,
	   * 
	   * 
	   * 
	   * ,
	   * 0
	   * 
	   * )
	   * ;
	   */
	  pw_polyline(pw, 0, 0, d, cirpnt, POLY_CLOSE, &bru, 0,
		      PIX_SRC | PIX_COLOR(dc));



	}
      }
      if (a == 83) {
	c = getc(in_file);
	if (c == 2) {
	  cfill1 = getc(in_file);
	  cfill2 = getc(in_file);
	}
	if (c == 130) {
	  cwid1 = getc(in_file);
	  cwid2 = getc(in_file);
	  lthc = (float) tx / 2.6;
	  if (cwid2 == 1)
	    cwid = (int) 1;
	  if (cwid2 == 30)
	    cwid = (int) 3 *lthc;

	  if (cwid2 == 80)
	    cwid = (int) 5 *lthc;

	  if (cwid2 == 175)
	    cwid = (int) 7 *lthc;

	  if (cwid2 == 19)
	    cwid = (int) 9 *lthc;

	  if (cwid <= 0)
	    cwid = 0;
	}
	if (c == 162) {
	  ccol = getc(in_file);
	  ccol = getc(in_file);
	  if ((printrun == FALSE) && (backgr == 1))
	    if (ccol == 1)
	      ccol = 0;
	}
	if (c == 98) {
	  d = getc(in_file);
	  d = getc(in_file);
	}
	if (c == 194) {
	  d = getc(in_file);
	  d = getc(in_file);
	}
      }
      if (a == 65) {
	b = getc(in_file);
	if (b == 134) {
	  d = 0;
	  dc = (ccol);
	  bru.width = (short) cwid;
	  ix1 = getc(in_file);
	  ix2 = getc(in_file);
	  iy1 = getc(in_file);
	  iy2 = getc(in_file);
	  ir1 = getc(in_file);
	  ir2 = getc(in_file);
	  px = (ix1 * 256 + ix2);
	  py = (iy1 * 256 + iy2);
	  pr = (ir1 * 256 + ir2);
	  x = (float) px;
	  y = (float) py;
	  r = (float) pr;
	  for (cth = 0.; cth <= 6.2831852; cth = cth + 0.3141592) {
	    x1 = x + r * cos(cth);
	    y1 = y + r * sin(cth);

	    x1 = (float) (x1 - cx);
	    y1 = (float) (y1 - cy);
	    x1 = (float) (x1 * tx);
	    y1 = (float) (y1 * ty);


	    ix1 = (int) x1;
	    iy1 = (int) (wsy - y1);
	    ix2 = (int) x2;
	    iy2 = (int) (wsy - y2);
	    if (printrun == TRUE) {
	      imed = iy1;
	      iy1 = ix1;
	      ix1 = wsy - imed;
	    }
	    if (ix1 < 65535 && ix1 > -65535) {
	      if (iy1 < 65535 && iy1 > -65535) {
		cirpnt[d].x = ix1;
		cirpnt[d++].y = iy1;
	      }
	    }
	  }
	  if (cfill1 == 0) {
	    if (cfill2 == 06)
	      cfill4 = 2;
	    if (cfill2 == 03)
	      cfill4 = 3;
	    if (cfill2 == 04)
	      cfill4 = 4;
	    if (cfill2 == 01)
	      cfill4 = 5;
	    if (cfill2 == 02)
	      cfill4 = 6;
	    if (cfill2 == 05)
	      cfill4 = 7;
	  }
	  if (cfill1 == 255) {
	    if (cfill2 == 246)
	      cfill4 = 10;
	    if (cfill2 == 245)
	      cfill4 = 11;
	    if (cfill2 == 244)
	      cfill4 = 12;
	    if (cfill2 == 243)
	      cfill4 = 13;
	    if (cfill2 == 241)
	      cfill4 = 14;
	  }
	  if (cfill3 == 1)
	    cfill4 = 1;
	  if (cfill3 == 4)
	    cfill4 = 8;
	  cfill1 = -1;
	  cfill2 = -1;
	  cfill3 = -1;
	  /*
	   * p
	   * 
	   * w
	   * _
	   * p o l y g o n _ 2 ( p w ,
	   * 
	   * 0 ,
	   * 
	   * 
	   * 
	   * ,
	   * 0
	   * 
	   * ,
	   * 1
	   * 
	   * ,
	   * &
	   * 
	   * d
	   * ,
	   * 
	   * c
	   * 
	   * i
	   * r
	   * 
	   * p
	   * n t ,
	   * 
	   * P ,
	   * 
	   * 
	   * 
	   * I
	   * X
	   * 
	   * _
	   * S R C
	   * 
	   * | C
	   * 
	   * 
	   * 
	   * P
	   * I
	   * X I
	   * 
	   * _
	   * C O L O R ( d c ) ,
	   * 
	   * m ,
	   * 
	   * 
	   * 
	   * p
	   * r
	   * 
	   * [
	   * c f i l l 4 ] ,
	   * 
	   * 0 ,
	   * 
	   * 
	   * 
	   * ,
	   * 0
	   * 
	   * )
	   * ;
	   */
	  pw_polyline(pw, 0, 0, d, cirpnt, POLY_CLOSE, &bru, 0,
		      PIX_SRC | PIX_COLOR(dc));



	}
      }
      if (a == 0) {
	c = getc(in_file);
	c = getc(in_file);
	c = getc(in_file);
	done = TRUE;
      }
    }
    fclose(in_file);
  }
  pw = canvas_pixwin(canvas);
}


static void
quit_proc( /* args unused */ )
{
  window_set(frame, FRAME_NO_CONFIRM, TRUE, 0);
  window_destroy(frame);
  exit(0);
}
static void
close_proc( /* */ )
{

  window_set(frame,
	     FRAME_CLOSED, TRUE,
	     0);
}


static void
_a4()
{
  ap = 4;
}
static void
_a3()
{
  ap = 3;
}
static void
_rdrw()
{
  if (ap == 3) {
    wx = (float) 0.;
    wy = (float) 0.;
    wlx = (float) 45514.752;
    wly = (float) 32767.00;
  }
  if (ap == 4) {
    wx = (float) -67.00;
    wy = (float) -104.00;
    wlx = (float) 27075.00;
    wly = (float) 17820.00;
  }
  redraw();
}
static void
_help()
{
  window_set(frame2, WIN_SHOW, TRUE, 0);

  window_set(helpwind, TEXTSW_FILE_CONTENTS,
	     addenv("help/metaview/hoh"),
	     TEXTSW_BROWSING, TRUE, 0);
  textsw_normalize_view(helpwind, (Textsw_index) 0);


}



static void
next_proc( /* */ )
{
  if ((fn + incremval) <= 99)
    fn = fn + incremval;
  _rdrw();
}
static void
prev_proc( /* */ )
{
  if ((fn - incremval) >= 1)
    fn = fn - incremval;
  _rdrw();
}

static void
font_load(fonts)
  int             fonts;
{
  int             c, x, y, d, si, cb, qsp;
  int             curt = 0, curs = 1;
  FILE           *in_file;

  cb = 0;
  if (fonts > 1)
    in_file = fopen(addenv("lib/metafont.swiss"), "r");
  else
    in_file = fopen(addenv("lib/metafont.ibmat"), "r");

  if (!in_file) {
	fprintf(stderr,"Failed to load font file please check\n");
	fprintf(stderr,"X_METAVIEW environment variable is set properly\n");
	exit(1);
  }

  c = getc(in_file);
  font[cb] = (int) c;
  ++cb;
  while (0 == (c == 32)) {
    if (curt > 20) {
      curt = 0;
      ++curs;
      if (curs > 6)
	curs = 1;
    }
    curt++;
    if (fonts > 1) {
      qsp = getc(in_file);
      font[cb] = (int) qsp;
      ++cb;
    }
    x = getc(in_file) - 32;
    font[cb] = (int) x;
    ++cb;
    while (0 == (x == 94)) {
      y = getc(in_file) - 32;
      font[cb] = (int) y;
      ++cb;
      d = getc(in_file) - 64;
      font[cb] = (int) d;
      ++cb;
      while (0 == (d == 62)) {
	d = getc(in_file) - 64;
	font[cb] = (int) d;
	++cb;
      }
      x = getc(in_file) - 32;
      font[cb] = (int) x;
      ++cb;
    }
    c = getc(in_file);
    font[cb] = (int) c;
    ++cb;
  }
  fclose(in_file);


  cb = 0;

  c = (int) font[cb];
  ++cb;
  while (0 == (c == 32)) {
    if (curt > 20) {
      curt = 0;
      ++curs;
      if (curs > 6)
	curs = 1;
    }
    curt++;
    indx[c] = cb - 1;
    if (fonts > 1)
      qsp = (int) font[cb];
    ++cb;

    x = (int) font[cb];
    ++cb;
    while (0 == (x == 94)) {

      y = (int) font[cb];
      ++cb;
      d = (int) font[cb];
      ++cb;
      while (0 == (d == 62)) {
	d = (int) font[cb];
	++cb;
      }
      x = (int) font[cb];
      ++cb;
    }

    c = (int) font[cb];
    ++cb;

  }
  curs = 0;
}

static void
vectex2(x, y, xa, tcol, txt, hx, hy)
  int             tcol, txt;
  float           x, y, xa, hx, hy;
{
  int             ix1, ix2, iy1, iy2;
  int             qcb, qc, qx, qy, qd;
  int             qrx, qry, qax, qay, qsp;
  register int    dc;
  float           x1, y1, x2, y2, rx1, rx2, ry1, ry2;
  struct pr_brush bru;


  if (txt > 32) {

    qcb = indx[txt];
    qc = (int) font[qcb];
    ++qcb;
    qsp = (int) font[qcb];
    ++qcb;
    qsp = qsp - 32;
    tsp = (float) (qsp);
    tsp = (float) (tsp + 5.);
    tsp = (float) (tsp / 14.);
    tsp = (float) (tsp * xa * art);


    qx = (int) font[qcb];
    ++qcb;
    while (0 == (qx == 94)) {
      if ((fontset & 1) == 1)
	bru.width = (short) ((int) (15.6 * tx));
      else
	bru.width = (short) 1;
      qy = (int) font[qcb];
      ++qcb;
      qd = (int) font[qcb];
      ++qcb;
      while (0 == (qd == 62)) {
	dc = (tcol);
	qrx = (qd % 3) - 1;
	qry = ((int) (qd / 3)) - 1;
	qax = qx + qrx;
	qay = (7 - qy) - qry;
	x1 = (float) (qx);
	x2 = (float) (qax);
	x1 = (float) x1 / 14;
	x2 = (float) x2 / 14;
	y1 = (float) (7 - qy);
	y2 = (float) (qay);
	y1 = (float) y1 / 26;
	y2 = (float) y2 / 26;
	x1 = x1 * 0.842;
	x2 = x2 * 0.842;
	y1 = y1 * 0.842;
	y2 = y2 * 0.842;
	x1 = (float) (x1 * xa * art);
	x2 = (float) (x2 * xa * art);
	y1 = (float) (y1 * xa);
	y2 = (float) (y2 * xa);
	x1 = (float) (x1 + x);
	x2 = (float) (x2 + x);
	y1 = (float) (y1 + y);
	y2 = (float) (y2 + y);
	x1 = (float) (x1 - cx);
	x2 = (float) (x2 - cx);
	y1 = (float) (y1 - cy);
	y2 = (float) (y2 - cy);
	x1 = (float) (x1 * tx);
	x2 = (float) (x2 * tx);
	y1 = (float) (y1 * ty);
	y2 = (float) (y2 * ty);
	x1 = (float) (x1 - hx);
	x2 = (float) (x2 - hx);
	y1 = (float) (y1 - hy);
	y2 = (float) (y2 - hy);
	rx1 = (float) ((matrix[1][1] * x1) + (matrix[2][1] * y1));
	rx2 = (float) ((matrix[1][1] * x2) + (matrix[2][1] * y2));
	ry1 = (float) ((matrix[1][2] * x1) + (matrix[2][2] * y1));
	ry2 = (float) ((matrix[1][2] * x2) + (matrix[2][2] * y2));

	rx1 = (float) (rx1 + hx);
	rx2 = (float) (rx2 + hx);
	ry1 = (float) (ry1 + hy);
	ry2 = (float) (ry2 + hy);
	ix1 = (int) rx1;
	iy1 = (int) ry1;
	ix2 = (int) rx2;
	iy2 = (int) ry2;
	if ((ix1 < 65535 && ix1 > -65535) &&
	    (ix2 < 65535 && ix2 > -65535) &&
	    (iy1 < 65535 && iy1 > -65535) &&
	    (iy2 < 65535 && iy2 > -65535)) {

	  iy1 = wsy - iy1;
	  iy2 = wsy - iy2;

	  if (printrun == TRUE) {
	    imed = iy1;
	    iy1 = ix1;
	    ix1 = wsy - imed;
	    imed = iy2;
	    iy2 = ix2;
	    ix2 = wsy - imed;
	  }
	  pw_line(pw, ix1, iy1, ix2, iy2, &bru, 0,
		  PIX_SRC | PIX_COLOR(dc));
	}
	qd = (int) font[qcb];
	++qcb;
      }
      qx = (int) font[qcb];
      ++qcb;
    }
  }
}

static void
vectex(x, y, xa, tcol, txt, hx, hy)
  int             tcol, txt;
  float           x, y, xa, hx, hy;
{
  int             ix1, ix2, iy1, iy2;
  int             qcb, qc, qx, qy, qd, qsp;
  int             qrx, qry, qax, qay;
  register int    dc;
  float           x1, y1, x2, y2, rx1, rx2, ry1, ry2;
  struct pr_brush bru;

  if (txt > 32) {
    qcb = indx[txt];
    qc = (int) font[qcb];
    ++qcb;
    qsp = 9.5;
    tsp = (float) (qsp);
    tsp = (float) (tsp + 5.);
    tsp = (float) (tsp / 14.);
    tsp = (float) (tsp * xa * art);


    qx = (int) font[qcb];
    ++qcb;
    while (0 == (qx == 94)) {
      if ((fontset & 1) == 1)
	bru.width = (short) ((int) (15.6 * tx));
      else
	bru.width = (short) 1;
      qy = (int) font[qcb];
      ++qcb;
      qd = (int) font[qcb];
      ++qcb;
      while (0 == (qd == 62)) {
	dc = (tcol);
	qrx = (qd % 3) - 1;
	qry = ((int) (qd / 3)) - 1;
	qax = qx + qrx;
	qay = (7 - qy) - qry;
	x1 = (float) (qx);
	x2 = (float) (qax);
	x1 = (float) x1 / 7;
	x2 = (float) x2 / 7;
	y1 = (float) (7 - qy);
	y2 = (float) (qay);
	y1 = (float) y1 / 13;
	y2 = (float) y2 / 13;
	x1 = (float) (x1 * xa * art);
	x2 = (float) (x2 * xa * art);
	y1 = (float) (y1 * xa);
	y2 = (float) (y2 * xa);
	x1 = (float) (x1 + x);
	x2 = (float) (x2 + x);
	y1 = (float) (y1 + y);
	y2 = (float) (y2 + y);
	x1 = (float) (x1 - cx);
	x2 = (float) (x2 - cx);
	y1 = (float) (y1 - cy);
	y2 = (float) (y2 - cy);
	x1 = (float) (x1 * tx);
	x2 = (float) (x2 * tx);
	y1 = (float) (y1 * ty);
	y2 = (float) (y2 * ty);
	x1 = (float) (x1 - hx);
	x2 = (float) (x2 - hx);
	y1 = (float) (y1 - hy);
	y2 = (float) (y2 - hy);
	rx1 = (float) ((matrix[1][1] * x1) + (matrix[2][1] * y1));
	rx2 = (float) ((matrix[1][1] * x2) + (matrix[2][1] * y2));
	ry1 = (float) ((matrix[1][2] * x1) + (matrix[2][2] * y1));
	ry2 = (float) ((matrix[1][2] * x2) + (matrix[2][2] * y2));

	rx1 = (float) (rx1 + hx);
	rx2 = (float) (rx2 + hx);
	ry1 = (float) (ry1 + hy);
	ry2 = (float) (ry2 + hy);
	ix1 = (int) rx1;
	iy1 = (int) ry1;
	ix2 = (int) rx2;
	iy2 = (int) ry2;
	if ((ix1 < 65535 && ix1 > -65535) &&
	    (ix2 < 65535 && ix2 > -65535) &&
	    (iy1 < 65535 && iy1 > -65535) &&
	    (iy2 < 65535 && iy2 > -65535)) {

	  iy1 = wsy - iy1;
	  iy2 = wsy - iy2;

	  if (printrun == TRUE) {
	    imed = iy1;
	    iy1 = ix1;
	    ix1 = wsy - imed;
	    imed = iy2;
	    iy2 = ix2;
	    ix2 = wsy - imed;
	  }
	  pw_line(pw, ix1, iy1, ix2, iy2, &bru, 0,
		  PIX_SRC | PIX_COLOR(dc));
	}
	qd = (int) font[qcb];
	++qcb;
      }
      qx = (int) font[qcb];
      ++qcb;
    }
  }
}


static void
setrot(th)
  float           th;
{
  double          thcf;

  thcf = (double) (th * cfac);
  matrix[1][1] = (float) (cos(thcf));
  matrix[2][1] = (float) (sin(thcf));
  matrix[2][1] = (float) (matrix[2][1] * -1.);
  matrix[1][2] = (float) (sin(thcf));
  matrix[2][2] = (float) (cos(thcf));
}
static void
rdproc( /* */ )
{
  redraw();
}
static void
font_proc(itm, value, evnt)
  Panel_item      itm;
  int             value;
  Event          *evnt;
{
  fontset = value;
  font_load(fontset);
  redraw();
}

static void
backgr_proc(itm, value, evnt)
  Panel_item      itm;
  int             value;
  Event          *evnt;
{
  int             tmp;

  /*
   * if (backgr != value) for (tmp = 1; tmp <= 8; tmp++) {
   * pr_rop(mpr[tmp], 0, 0, mpr[tmp]->pr_size.x, mpr[tmp]->pr_size.y,
   * PIX_NOT(PIX_SRC), mpr[tmp], 0, 0); } for (tmp = 10; tmp <= 14; tmp++)
   * { pr_rop(mpr[tmp], 0, 0, mpr[tmp]->pr_size.x, mpr[tmp]->pr_size.y,
   * PIX_NOT(PIX_SRC), mpr[tmp], 0, 0); }
   */
  backgr = value;
  redraw();
}







static void
inc_proc(itm, value, evnt)
  Panel_item      itm;
  int             value;
  Event          *evnt;
{
  incremval = value + 1;
}




static          Notify_value
_winevent(evwin, evnt, evargs)
  Window          evwin;
  Event          *evnt;
  caddr_t         evargs;
{
  int             eventac;
  int             cx1, cx2, cy1, cy2, cx21, cx11, msorang, evx, evy,
                  evxca, evyca, cw, ch;
  register int    dc;

  cw = (int) window_get(canvas, WIN_WIDTH);
  ch = (int) window_get(canvas, WIN_HEIGHT);


  eventac = event_action(evnt);
  if ((int) event_middle_is_down(evnt) != 0) {
    if (bth == 1) {
      wx = (float) (nwx);
      wy = (float) (nwy);
      wlx = (float) (nwlx);
      wly = (float) (nwly);
      dc = (1);
      cx1 = (int) voldsex;
      cx2 = (int) oldenx;
      cy1 = (int) voldsey;
      cy2 = (int) oldeny;

      pw_vector(pw, cx1, cy1, 0, 0, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
      pw_vector(pw, cx2, cy1, 1141, 0, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc),0);
      pw_vector(pw, cx1, cy2, 0, 821, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
      pw_vector(pw, cx2, cy2, 1141, 821, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
      redraw();
      bth = 0;
    }
    return (0);
  }
  if ((int) event_right_is_down(evnt) != 0) {
    dc = (1);
    cx1 = (int) 420;
    cx2 = (int) 721;
    cy1 = (int) 300;
    cy2 = (int) 500;
    cx11 = cx1 + 1;
    cx21 = cx2 - 1;
    pw_vector(pw, cx1, cy1, cx1, cy2, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
    pw_vector(pw, cx2, cy1, cx2, cy2, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
    pw_vector(pw, cx11, cy1, cx21, cy1, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
    pw_vector(pw, cx11, cy2, cx21, cy2, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
    pw_vector(pw, cx1, cy1, 0, 0, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
    pw_vector(pw, cx2, cy1, 1141, 0, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
    pw_vector(pw, cx1, cy2, 0, 821, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
    pw_vector(pw, cx2, cy2, 1141, 821, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
    _rdrw();
    bth = 0;
    return (0);
  }
  if ((eventac == LOC_DRAG) && ((int) event_left_is_down(evnt) != 0)) {
    if (bth == 1) {
      dc = (1);
      cx1 = (int) voldsex;
      cx2 = (int) oldenx;
      cy1 = (int) voldsey;
      cy2 = (int) oldeny;
      cx11 = cx1 + 1;
      cx21 = cx2 - 1;
      pw_vector(pw, cx1, cy1, cx1, cy2, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
      pw_vector(pw, cx2, cy1, cx2, cy2, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
      pw_vector(pw, cx11, cy1, cx21, cy1, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
      pw_vector(pw, cx11, cy2, cx21, cy2, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
      bth = 0;
    }
    voldsex = oldsex;
    voldsey = oldsey;



    msorang = 0;
    evx = (int) event_x(evnt);
    evy = (int) event_y(evnt);
    if (evx < oldsex) {
      evx = oldsex;
      msorang = 1;
    }
    if (evy < oldsey) {
      evy = oldsey;
      msorang = 1;
    }
    evyca = oldsey + (int) (evx - oldsex) * (821. / 1141.);
    evxca = evx;

    if (evyca < evy) {
      evxca = oldsex + (int) (evy - oldsey) * (1141. / 821.);
      evyca = evy;
    }
    if ((evx != evxca) || (evy != evyca))
      /*window_set(evwin, WIN_MOUSE_XY, evxca, evyca, 0);*/


    dc = (1);
    if (jdrb == 1) {
      cx1 = (int) oldsex;
      cx2 = (int) oldenx;
      cy1 = (int) oldsey;
      cy2 = (int) oldeny;
      cx11 = cx1 + 1;
      cx21 = cx2 - 1;
      pw_vector(pw, cx1, cy1, cx1, cy2, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
      pw_vector(pw, cx2, cy1, cx2, cy2, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
      pw_vector(pw, cx11, cy1, cx21, cy1, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
      pw_vector(pw, cx11, cy2, cx21, cy2, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
      jdrb = 0;
    }
    cx1 = (int) oldsex;
    cx2 = evxca;
    cy1 = (int) oldsey;
    cy2 = evyca;
    oldenx = cx2;
    oldeny = cy2;
    cx11 = cx1 + 1;
    cx21 = cx2 - 1;
    pw_vector(pw, cx1, cy1, cx1, cy2, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
    pw_vector(pw, cx2, cy1, cx2, cy2, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
    pw_vector(pw, cx11, cy1, cx21, cy1, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
    pw_vector(pw, cx11, cy2, cx21, cy2, (PIX_SRC ^ PIX_DST) ^ PIX_COLOR(dc), 0);
    jdrb = 1;
    oldenx = cx2;
    oldeny = cy2;
  } else {
    dc = (1);
    if (jdrb == 1) {
      bth = 1;
      jdrb = 0;
      nwx = (float) oldsex;
      nwy = (float) (ch - oldeny);
      nwlx = (float) (oldenx - oldsex);
      nwly = (float) ((ch - oldsey) - (ch - oldeny));
      nwx = (float) (nwx / tx);
      nwy = (float) (nwy / ty);
      nwlx = (float) (nwlx / tx);
      nwly = (float) (nwly / ty);
      nwx = -(float) (nwx + cx);
      nwy = -(float) (nwy + cy);
    }
    oldsex = event_x(evnt);
    oldsey = event_y(evnt);
  }
  return (0);
}







/*
 * static void create_fills() { int d; register int dc = 1;
 * 
 * for (d = 0; d <= 8; ++d) mpr[d] = real_mem_create(20, 20, 1);
 * pr_rop(mpr[1], 0, 0, 20, 20, PIX_SRC | PIX_COLOR(1), (Pixrect *) 0, 0,
 * 0);
 * 
 * pr_vector(mpr[2], 0, 0, 19, 19, PIX_SRC | PIX_COLOR(dc), 0);
 * pr_vector(mpr[2], 19, 0, 0, 19, PIX_SRC | PIX_COLOR(dc), 0);
 * pr_vector(mpr[2], 9, 0, 0, 9, PIX_SRC | PIX_COLOR(dc), 0);
 * pr_vector(mpr[2], 0, 9, 9, 19, PIX_SRC | PIX_COLOR(dc), 0);
 * pr_vector(mpr[2], 9, 19, 19, 9, PIX_SRC | PIX_COLOR(dc), 0);
 * pr_vector(mpr[2], 19, 9, 9, 0, PIX_SRC | PIX_COLOR(dc), 0);
 * 
 * pr_vector(mpr[3], 9, 0, 0, 9, PIX_SRC | PIX_COLOR(dc), 0);
 * pr_vector(mpr[3], 19, 0, 0, 19, PIX_SRC | PIX_COLOR(dc), 0);
 * pr_vector(mpr[3], 9, 19, 19, 9, PIX_SRC | PIX_COLOR(dc), 0);
 * 
 * pr_vector(mpr[4], 0, 9, 9, 19, PIX_SRC | PIX_COLOR(dc), 0);
 * pr_vector(mpr[4], 0, 0, 19, 19, PIX_SRC | PIX_COLOR(dc), 0);
 * pr_vector(mpr[4], 19, 9, 9, 0, PIX_SRC | PIX_COLOR(dc), 0);
 * 
 * pr_vector(mpr[5], 0, 0, 19, 19, PIX_SRC | PIX_COLOR(dc), 0);
 * pr_vector(mpr[5], 19, 0, 0, 19, PIX_SRC | PIX_COLOR(dc), 0);
 * 
 * pr_vector(mpr[6], 19, 0, 0, 19, PIX_SRC | PIX_COLOR(dc), 0);
 * 
 * pr_vector(mpr[7], 0, 0, 19, 19, PIX_SRC | PIX_COLOR(dc), 0);
 * 
 * for (d = 10; d <= 12; ++d) mpr[d] = real_mem_create(2, 2, 1);
 * pr_put(mpr[10], 0, 1, 1); pr_put(mpr[10], 1, 0, 1); pr_put(mpr[10], 1,
 * 1, 1);
 * 
 * pr_put(mpr[11], 0, 0, 1); pr_put(mpr[11], 1, 1, 1);
 * 
 * pr_put(mpr[12], 0, 0, 1);
 * 
 * mpr[13] = real_mem_create(4, 4, 1); mpr[14] = real_mem_create(4, 4, 1);
 * 
 * pr_put(mpr[13], 0, 0, 1); pr_put(mpr[13], 2, 2, 1);
 * 
 * pr_put(mpr[14], 0, 0, 1);
 * 
 * }
 */
